VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SC2 Cliff Height Scaler"
   ClientHeight    =   1545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7095
   LinkTopic       =   "Form1"
   ScaleHeight     =   1545
   ScaleWidth      =   7095
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text3 
      Height          =   375
      Left            =   1080
      TabIndex        =   5
      Text            =   "C:\Program Files (x86)\StarCraft II\Work\Assets\Cliffs\CliffNatural0_2x"
      Top             =   600
      Width           =   6015
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   1080
      TabIndex        =   2
      Text            =   "C:\Program Files (x86)\StarCraft II\Work\Assets\Cliffs\CliffNatural0"
      Top             =   120
      Width           =   6015
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Text            =   "2.0"
      Top             =   1080
      Width           =   855
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Scale"
      Height          =   375
      Left            =   2040
      TabIndex        =   0
      Top             =   1080
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "By DeProgrammer (SC2Mapster)"
      Height          =   255
      Left            =   4560
      TabIndex        =   7
      Top             =   1200
      Width           =   2415
   End
   Begin VB.Label Label3 
      Caption         =   "Scale:"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   1200
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Destination:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   720
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Source:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim fileBuffer() As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private outputName As String
Private heightFactor As Single

Private Sub Command1_Click()
Dim scaleAttempts As Integer, scaleSuccesses As Integer

Command1.Enabled = False
Command1.Caption = "Working..."
    
If Len(Text2.Text) < 3 Then
    MsgBox "Source must be a valid path name."
    Command1.Enabled = True
    Command1.Caption = "Scale"
    Exit Sub
End If
Text2.Text = Replace(Text2.Text, "/", "\") 'Convert all forward slashes to backslashes
If Mid(Text2.Text, Len(Text2.Text), 1) <> "\" Then Text2.Text = Text2.Text & "\" 'Make sure it ends with a \

If Len(Text3.Text) < 3 Then
    MsgBox "Destination must be a valid path name."
    Command1.Enabled = True
    Command1.Caption = "Scale"
    Exit Sub
End If
Text3.Text = Replace(Text3.Text, "/", "\") 'Convert all forward slashes to backslashes
If Mid(Text3.Text, Len(Text3.Text), 1) <> "\" Then Text3.Text = Text3.Text & "\" 'Make sure it ends with a \

If Not IsNumeric(Text1.Text) Then
    MsgBox "Scale value must be numeric. Please use . as the decimal separator."
    Command1.Enabled = True
    Command1.Caption = "Scale"
End If
heightFactor = CSng(Text1.Text)

On Error Resume Next
outputName = Mid(Text3.Text, InStrRev(Text3.Text, "\", Len(Text3.Text) - 1)) 'Get the name starting at the second to last \. Can error.
outputName = Mid(outputName, 1, Len(outputName) - 1) 'Remove the last \

MkDir Text3.Text
file = Dir(Text2.Text)
If file = "" Then MsgBox "The source path does not exist."
Do
    On Error GoTo wellsnap
    
    scaleAttempts = scaleAttempts + 1
    Open Text2.Text & file For Binary Access Read As #1
    ReDim fileBuffer(0 To LOF(1) \ 4 - 1) As Long
    Get #1, 1, fileBuffer
    Close #1
    
    modifyVertices
    
    'Modify file name
    On Error GoTo wellsnap
    Open Text3.Text & outputName & Mid(file, InStr(1, file, "_")) For Binary Access Write As #1
    Put #1, 1, fileBuffer
    Close #1
    
    scaleSuccesses = scaleSuccesses + 1
wellsnap:
    On Error GoTo outOfDo
    file = Dir
    If file = ".." Or file = "." Or file = "" Then Exit Do
Loop
outOfDo:

Command1.Enabled = True
Command1.Caption = "Scale"
MsgBox "Attempted model scales: " & scaleAttempts & ". Success count: " & scaleSuccesses & "."
End Sub

Private Sub modifyVertices()
Dim firstVertex As Long, vertexCountTimesEight As Long, X As Integer, Z As Integer
For X = 0 To UBound(fileBuffer)
    If fileBuffer(X) = 1429757791 Then 'Find "__8U", which is the vertex block ID thingy
        'Seek to first vertex
        firstVertex = fileBuffer(X + 1) \ 4
        vertexCountTimesEight = fileBuffer(X + 2) \ 4
        
        'Modify height of each vertex
        For Z = 2 To vertexCountTimesEight - 5 Step 8
            fileBuffer(firstVertex + Z) = FromFloat(ToFloat(fileBuffer(firstVertex + Z)) * heightFactor)
        Next Z
        
        Exit Sub
    End If
Next X
End Sub

Private Function ToFloat(longBits As Long) As Single
Dim singleBits As Single
CopyMemory singleBits, longBits, 4
ToFloat = singleBits
End Function

Private Function FromFloat(singleBits As Single) As Long
Dim longBits As Long
CopyMemory longBits, singleBits, 4
FromFloat = longBits
End Function

Private Sub Form_Resize()
Text2.Width = Me.ScaleWidth - Text2.Left
Text3.Width = Text2.Width
Label4.Left = Me.ScaleWidth - Label4.Width - 120
End Sub
